/*
 * Ported from Flashlight VNC ActionScript implementation:
 *     http://www.wizhelp.com/flashlight-vnc/
 *
 * Full attribution follows:
 *
 * -------------------------------------------------------------------------
 *
 * This DES class has been extracted from package Acme.Crypto for use in VNC.
 * The unnecessary odd parity code has been removed.
 *
 * These changes are:
 *  Copyright (C) 1999 AT&T Laboratories Cambridge.  All Rights Reserved.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *

 * DesCipher - the DES encryption method
 *
 * The meat of this code is by Dave Zimmerman <dzimm@widget.com>, and is:
 *
 * Copyright (c) 1996 Widget Workshop, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL or COMMERCIAL purposes and
 * without fee is hereby granted, provided that this copyright notice is kept 
 * intact. 
 * 
 * WIDGET WORKSHOP MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. WIDGET WORKSHOP SHALL NOT BE LIABLE
 * FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  WIDGET WORKSHOP
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 *
 *
 * The rest is:
 *
 * Copyright (C) 1996 by Jef Poskanzer <jef@acme.com>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the ACME Labs Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.acme.com/java/
 */
"use strict";function DES(e){function t(e){var t,a,o,r,s,i,n,l,u,d,c=[],p=[],m=[];for(a=0,o=56;56>a;++a,o-=8)o+=-5>o?65:-3>o?31:-1>o?63:27===o?35:0,r=7&o,c[a]=0!==(e[o>>>3]&1<<r)?1:0;for(t=0;16>t;++t){for(r=t<<1,s=r+1,m[r]=m[s]=0,i=28;59>i;i+=28)for(a=i-28;i>a;++a)o=a+y[t],i>o?p[a]=c[o]:p[a]=c[o-28];for(a=0;24>a;++a)0!==p[b[a]]&&(m[r]|=1<<23-a),0!==p[b[a+24]]&&(m[s]|=1<<23-a)}for(t=0,u=0,d=0;16>t;++t)n=m[u++],l=m[u++],A[d]=(16515072&n)<<6,A[d]|=(4032&n)<<10,A[d]|=(16515072&l)>>>10,A[d]|=(4032&l)>>>6,++d,A[d]=(258048&n)<<12,A[d]|=(63&n)<<16,A[d]|=(258048&l)>>>4,A[d]|=63&l,++d}function a(e){var t,a,o,r,s=0,i=e.slice(),n=0;for(a=i[s++]<<24|i[s++]<<16|i[s++]<<8|i[s++],o=i[s++]<<24|i[s++]<<16|i[s++]<<8|i[s++],r=252645135&(a>>>4^o),o^=r,a^=r<<4,r=65535&(a>>>16^o),o^=r,a^=r<<16,r=858993459&(o>>>2^a),a^=r,o^=r<<2,r=16711935&(o>>>8^a),a^=r,o^=r<<8,o=o<<1|o>>>31&1,r=2863311530&(a^o),a^=r,o^=r,a=a<<1|a>>>31&1,s=0;8>s;++s)r=o<<28|o>>>4,r^=A[n++],t=g[63&r],t|=h[r>>>8&63],t|=p[r>>>16&63],t|=d[r>>>24&63],r=o^A[n++],t|=v[63&r],t|=f[r>>>8&63],t|=m[r>>>16&63],t|=c[r>>>24&63],a^=t,r=a<<28|a>>>4,r^=A[n++],t=g[63&r],t|=h[r>>>8&63],t|=p[r>>>16&63],t|=d[r>>>24&63],r=a^A[n++],t|=v[63&r],t|=f[r>>>8&63],t|=m[r>>>16&63],t|=c[r>>>24&63],o^=t;for(o=o<<31|o>>>1,r=2863311530&(a^o),a^=r,o^=r,a=a<<31|a>>>1,r=16711935&(a>>>8^o),o^=r,a^=r<<8,r=858993459&(a>>>2^o),o^=r,a^=r<<2,r=65535&(o>>>16^a),a^=r,o^=r<<16,r=252645135&(o>>>4^a),a^=r,o^=r<<4,r=[o,a],s=0;8>s;s++)i[s]=(r[s>>>2]>>>8*(3-s%4))%256,i[s]<0&&(i[s]+=256);return i}function o(e){return a(e.slice(0,8)).concat(a(e.slice(8,16)))}var r,s,i,n,l,u,d,c,p,m,h,f,g,v,b=[13,16,10,23,0,4,2,27,14,5,20,9,22,18,11,3,25,7,15,6,26,19,12,1,40,51,30,36,46,54,29,39,50,44,32,47,43,48,38,55,33,52,45,41,49,35,28,31],y=[1,2,4,6,8,10,12,14,15,17,19,21,23,25,27,28],w=0,A=[];return r=65536,s=1<<24,i=r|s,n=4,l=1024,u=n|l,d=[i|l,w|w,r|w,i|u,i|n,r|u,w|n,r|w,w|l,i|l,i|u,w|l,s|u,i|n,s|w,w|n,w|u,s|l,s|l,r|l,r|l,i|w,i|w,s|u,r|n,s|n,s|n,r|n,w|w,w|u,r|u,s|w,r|w,i|u,w|n,i|w,i|l,s|w,s|w,w|l,i|n,r|w,r|l,s|n,w|l,w|n,s|u,r|u,i|u,r|n,i|w,s|u,s|n,w|u,r|u,i|l,w|u,s|l,s|l,w|w,r|n,r|l,w|w,i|n],r=1<<20,s=1<<31,i=r|s,n=32,l=32768,u=n|l,c=[i|u,s|l,w|l,r|u,r|w,w|n,i|n,s|u,s|n,i|u,i|l,s|w,s|l,r|w,w|n,i|n,r|l,r|n,s|u,w|w,s|w,w|l,r|u,i|w,r|n,s|n,w|w,r|l,w|u,i|l,i|w,w|u,w|w,r|u,i|n,r|w,s|u,i|w,i|l,w|l,i|w,s|l,w|n,i|u,r|u,w|n,w|l,s|w,w|u,i|l,r|w,s|n,r|n,s|u,s|n,r|n,r|l,w|w,s|l,w|u,s|w,i|n,i|u,r|l],r=1<<17,s=1<<27,i=r|s,n=8,l=512,u=n|l,p=[w|u,i|l,w|w,i|n,s|l,w|w,r|u,s|l,r|n,s|n,s|n,r|w,i|u,r|n,i|w,w|u,s|w,w|n,i|l,w|l,r|l,i|w,i|n,r|u,s|u,r|l,r|w,s|u,w|n,i|u,w|l,s|w,i|l,s|w,r|n,w|u,r|w,i|l,s|l,w|w,w|l,r|n,i|u,s|l,s|n,w|l,w|w,i|n,s|u,r|w,s|w,i|u,w|n,r|u,r|l,s|n,i|w,s|u,w|u,i|w,r|u,w|n,i|n,r|l],r=8192,s=1<<23,i=r|s,n=1,l=128,u=n|l,m=[i|n,r|u,r|u,w|l,i|l,s|u,s|n,r|n,w|w,i|w,i|w,i|u,w|u,w|w,s|l,s|n,w|n,r|w,s|w,i|n,w|l,s|w,r|n,r|l,s|u,w|n,r|l,s|l,r|w,i|l,i|u,w|u,s|l,s|n,i|w,i|u,w|u,w|w,w|w,i|w,r|l,s|l,s|u,w|n,i|n,r|u,r|u,w|l,i|u,w|u,w|n,r|w,s|n,r|n,i|l,s|u,r|n,r|l,s|w,i|n,w|l,s|w,r|w,i|l],r=1<<25,s=1<<30,i=r|s,n=256,l=1<<19,u=n|l,h=[w|n,r|u,r|l,i|n,w|l,w|n,s|w,r|l,s|u,w|l,r|n,s|u,i|n,i|l,w|u,s|w,r|w,s|l,s|l,w|w,s|n,i|u,i|u,r|n,i|l,s|n,w|w,i|w,r|u,r|w,i|w,w|u,w|l,i|n,w|n,r|w,s|w,r|l,i|n,s|u,r|n,s|w,i|l,r|u,s|u,w|n,r|w,i|l,i|u,w|u,i|w,i|u,r|l,w|w,s|l,i|w,w|u,r|n,s|n,w|l,w|w,s|l,r|u,s|n],r=1<<22,s=1<<29,i=r|s,n=16,l=16384,u=n|l,f=[s|n,i|w,w|l,i|u,i|w,w|n,i|u,r|w,s|l,r|u,r|w,s|n,r|n,s|l,s|w,w|u,w|w,r|n,s|u,w|l,r|l,s|u,w|n,i|n,i|n,w|w,r|u,i|l,w|u,r|l,i|l,s|w,s|l,w|n,i|n,r|l,i|u,r|w,w|u,s|n,r|w,s|l,s|w,w|u,s|n,i|u,r|l,i|w,r|u,i|l,w|w,i|n,w|n,w|l,i|w,r|u,w|l,r|n,s|u,w|w,i|l,s|w,r|n,s|u],r=1<<21,s=1<<26,i=r|s,n=2,l=2048,u=n|l,g=[r|w,i|n,s|u,w|w,w|l,s|u,r|u,i|l,i|u,r|w,w|w,s|n,w|n,s|w,i|n,w|u,s|l,r|u,r|n,s|l,s|n,i|w,i|l,r|n,i|w,w|l,w|u,i|u,r|l,w|n,s|w,r|l,s|w,r|l,r|w,s|u,s|u,i|n,i|n,w|n,r|n,s|w,s|l,r|w,i|l,w|u,r|u,i|l,w|u,s|n,i|u,i|w,r|l,w|w,w|n,i|u,w|w,r|u,i|w,w|l,s|n,s|l,w|l,r|n],r=1<<18,s=1<<28,i=r|s,n=64,l=4096,u=n|l,v=[s|u,w|l,r|w,i|u,s|w,s|u,w|n,s|w,r|n,i|w,i|u,r|l,i|l,r|u,w|l,w|n,i|w,s|n,s|l,w|u,r|l,r|n,i|n,i|l,w|u,w|w,w|w,i|n,s|n,s|l,r|u,r|w,r|u,r|w,i|l,w|l,w|n,i|n,w|l,r|u,s|l,w|n,s|n,i|w,i|n,s|w,r|w,s|u,w|w,i|u,r|n,s|n,i|w,s|l,s|u,w|w,i|u,r|l,r|l,w|u,w|u,r|n,s|w,i|l],t(e),{encrypt:o}}