/*
 * Websock: high-performance binary WebSockets
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * Websock is similar to the standard WebSocket object but Websock
 * enables communication with raw TCP sockets (i.e. the binary stream)
 * via websockify. This is accomplished by base64 encoding the data
 * stream between Websock and websockify.
 *
 * Websock has built-in receive queue buffering; the message event
 * does not contain actual data but is simply a notification that
 * there is new data available. Several rQ* methods are available to
 * read binary data off of the receive queue.
 */
function Websock(){"use strict";function e(){return I}function t(){return k}function a(){return x}function o(e){x=e}function r(){return k.length-x}function s(){return k[x]}function i(){return k[x++]}function n(e){0===x?k.unshift(e):(x-=1,k[x]=e)}function l(){return(k[x++]<<8)+k[x++]}function u(){return(k[x++]<<24)+(k[x++]<<16)+(k[x++]<<8)+k[x++]}function d(e){"undefined"==typeof e&&(e=r());var t=k.slice(x,x+e);return x+=e,t.map(function(e){return String.fromCharCode(e)}).join("")}function c(e){return"undefined"==typeof e&&(e=r()),x+=e,k.slice(x-e,x)}function p(e,t){return t?k.slice(x+e,x+t):k.slice(x+e)}function m(e,t,a){var o=k.length-x;if(t>o){if(a){if(a>x)throw"rQwait cannot backup "+a+" bytes";x-=a}return!0}return!1}function h(){return Base64.encode(I)}function f(e){k=k.concat(Base64.decode(e,0))}function g(){return 0!==E.bufferedAmount&&Util.Debug("bufferedAmount: "+E.bufferedAmount),E.bufferedAmount<_.maxBufferedAmount?(I.length>0&&(E.send(h(I)),I=[]),!0):(Util.Info("Delaying send, bufferedAmount: "+E.bufferedAmount),!1)}function v(e){return I=I.concat(e),g()}function b(e){_.send(e.split("").map(function(e){return e.charCodeAt(0)}))}function y(e){try{f(e.data),r()>0?(N.message(),k.length>F&&(k=k.slice(x),x=0)):Util.Debug("Ignoring empty message")}catch(t){"undefined"!=typeof t.stack?Util.Warn("recv_message, caught exception: "+t.stack):"undefined"!=typeof t.description?Util.Warn("recv_message, caught exception: "+t.description):Util.Warn("recv_message, caught exception:"+t),"undefined"!=typeof t.name?N.error(t.name+": "+t.message):N.error(t)}}function w(e,t){N[e]=t}function A(){k=[],x=0,I=[],E=null}function C(e){A(),E=L?{}:new WebSocket(e,"base64"),E.onmessage=y,E.onopen=function(){Util.Debug(">> WebSock.onopen"),E.protocol&&Util.Info("Server chose sub-protocol: "+E.protocol),N.open(),Util.Debug("<< WebSock.onopen")},E.onclose=function(e){Util.Debug(">> WebSock.onclose"),N.close(e),Util.Debug("<< WebSock.onclose")},E.onerror=function(e){Util.Debug(">> WebSock.onerror: "+e),N.error(e),Util.Debug("<< WebSock.onerror")}}function S(){E&&((E.readyState===WebSocket.OPEN||E.readyState===WebSocket.CONNECTING)&&(Util.Info("Closing WebSocket connection"),E.close()),E.onmessage=function(e){})}function P(e){return L=!0,_.send=e,_.close=function(){},y}function D(){return _.maxBufferedAmount=200,_.get_sQ=e,_.get_rQ=t,_.get_rQi=a,_.set_rQi=o,_.rQlen=r,_.rQpeek8=s,_.rQshift8=i,_.rQunshift8=n,_.rQshift16=l,_.rQshift32=u,_.rQshiftStr=d,_.rQshiftBytes=c,_.rQslice=p,_.rQwait=m,_.flush=g,_.send=v,_.send_string=b,_.on=w,_.init=A,_.open=C,_.close=S,_.testMode=P,_}var _={},E=null,k=[],x=0,F=1e4,I=[],N={message:function(){},open:function(){},close:function(){},error:function(){}},L=!1;return D()}window.WebSocket&&!window.WEB_SOCKET_FORCE_FLASH?Websock_native=!0:window.MozWebSocket&&!window.WEB_SOCKET_FORCE_FLASH?(Websock_native=!0,window.WebSocket=window.MozWebSocket):(Websock_native=!1,function(){function e(){return"undefined"!=typeof INCLUDE_URI?INCLUDE_URI:"include/"}var t="<script src='"+e(),a="'></script>",o="";window.WEB_SOCKET_SWF_LOCATION=e()+"web-socket-js/WebSocketMain.swf",Util.Engine.trident&&(Util.Debug("Forcing uncached load of WebSocketMain.swf"),window.WEB_SOCKET_SWF_LOCATION+="?"+Math.random()),o+=t+"web-socket-js/swfobject.js"+a,o+=t+"web-socket-js/web_socket.js"+a,document.write(o)}());